<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.meludi");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
%>
<base:page type="default" >
<base:head 
	scripts="~../meludi-2.js,~labelgeneration.js" 
	styles="path.css,~../css/meludi-2.css"
	>
<style>
tr.highlight
{
	border-top: 1px dotted #A0A0A0;
	border-bottom: 1px solid transparent;
}

.dottedleft
{
	border-left: 1px dotted #A0A0A0;
}
</style>
</base:head>
<base:body>

	<p:path><p:pathelement 
		title="" href="<%="../index.jsp?ID="+ID%>" 
		/><p:pathelement title="Label generation" 
		/></p:path>

	<div class="content">

	<form name="meludi" id="wizard" class="wizard">
	
	<div class="step" id="step-1">
		<div class="step-no">1</div>
		<div class="step-title">Select label parameters</div>
		<div class="step-content">
	
			<table class="step-form">
			<tr>
				<td class="prompt">Number of cases</td>
				<td class="input">
					<input type="text" name="nofCases" id="nofCases"
						class="required auto-init" data-auto-init="focus-on-enter" data-next-focus="nofTubesPerCase"
					  	style="width: 12em;" maxlength="4" value="1">
				</td>
				<td class="status" id="nofCases.status"></td>
				<td class="help">
					<span id="nofCases.message" class="message"></span>
					Number of cases to generate labels for.
				</td>
			</tr>
			<tr>
				<td class="prompt">Max number of tubes/case</td>
				<td class="input">
					<select name="nofTubesPerCase" id="nofTubesPerCase"
						class="auto-init" data-auto-init="focus-on-enter" data-next-focus="caseName">
						<option value="1">1
						<option selected value="2">2
						<option value="3">3
						<option value="4">4
						<option value="5">5
						<option value="6">6
						<option value="7">7
						<option value="8">8
						<option value="9">9
					</select>
				</td>
				<td class="status" id="nofTubesPerCase.status"></td>
				<td class="help">
					<span id="nofTubesPerCase.message" class="message"></span>
					Max number of tubes per case.
				</td>
			</tr>
			<tr>
				<td class="prompt">Start case name</td>
				<td class="input">
					<input type="text" name="caseName" id="caseName"
						class="required auto-init" data-auto-init="focus" data-next-focus="gopreview"
						style="width: 12em;" maxlength="12">
				</td>
				<td class="status" id="caseName.status"></td>
				<td class="help">
					<span id="caseName.message" class="message"></span>
					Start case (barcode) for generated labels.
				</td>
			</tr>
			</table>
		</div>
	</div>
	
	<div id="wizard-status"></div>

	<table class="navigation" id="navigation">
	<tr>
		<td><base:button id="gopreview" title="Preview" image="<%=home+"/images/export.png"%>" /></td>
		<td><base:button id="goexport" title="Download" image="<%=home+"/images/download.png"%>" /></td>
	</tr>
	</table>
	
	<div id="previewWrapper" style="display: none;">
		<div>
			<span id="previewTitle">Preview</span>
			<span id="previewWarning"></span>
		</div>
		<div id="previewList"></div>
	</div>
	</form>
	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>